/* This script creates the CD player objects in the
   multimedia folder. */

 call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
 call SysLoadFuncs

PARSE source . . thePath
FILESPEC('drive', thePath)||FILESPEC('path', thePath)'createcd.exe'
exit


/* Find MMPM2.INI file */
MMPM2ini=VALUE('MMBASE',,'OS2ENVIRONMENT')

thePos=POS(';',MMPM2ini)
IF thePOS\=0 THEN
	MMPM2ini=LEFT(MMPM2ini, thePos-1)

MMPM2ini=MMPM2ini||'\MMPM2.ini'

IF STREAM(MMPM2ini,'C','QUERY EXISTS')=''
	THEN EXIT

allCD.=''
allCD.0=0

/* Get the CD drives known to MMOS2 */
call getAllCD MMPM2ini


/* Create CD-Player objects */
DO a=1 to allCD.0
	setup='CDPLAYERDRIVE='||allCD.a._drive||';OBJECTID=<CWMM_CDPLAYER_'||STRIP(TRANSLATE(allCD.a._drive,' ',':'))||'>'
	rc=SysCreateObject("CWCDFolder",'CD-Audio^Drive '||allCD.a._drive, '<MMPM2_FOLDER>',setup,'update')
END

/* Delete wrong CD players */
DO a=3 to 25
	found=0
	DO b=1 to allCD.0
		if STRIP(TRANSLATE(allCD.b._drive,' ',':'))=D2C(65+a) THEN found=1
	END
	if FOUND\=1 THEN
		rc=SysDestroyObject('<CWMM_CDPLAYER_'||D2C(65+a)||'>')
END

EXIT

/***************/
getAllCD:

theIni=ARG(1)
ini.=''

a=0
DO WHILE LINES(theINI)=1
	a=a+1
	ini.a=LINEIN(theIni)
END
ini.0=a
rc=STREAM(theIni,'C','close')

DO a=1 to ini.0

	SELECT
	  WHEN POS('[IBMCDAUDIO', STRIP(TRANSLATE(ini.a)))=1 THEN
		call parseSection a
	OTHERWISE
		NOP
	END
END
return

/****************/
parseSection:
	
DO a=a+1 to ini.0
	SELECT
	  WHEN POS('[', STRIP(TRANSLATE(ini.a)))=1 THEN DO
		/* Next section reached */
		a=a-1
		return
	  END
	  WHEN POS('RESOURCENAME', STRIP(TRANSLATE(ini.a)))=1 THEN DO
		/* The entry for the drive letter */
		allCD.0=allCD.0+1
		idx=allCD.0
		thePos=LASTPOS('=',ini.a)
		allCD.idx._drive=TRANSLATE(STRIP(RIGHT(ini.a,LENGTH(ini.a)-thePos)))
	  END
	OTHERWISE
		NOP
	END	
END
return